// BeauGaugeExample002Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "BeauGaugeExample002.h"
#include "BeauGaugeExample002Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBeauGaugeExample002Dlg dialog

CBeauGaugeExample002Dlg::CBeauGaugeExample002Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBeauGaugeExample002Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBeauGaugeExample002Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBeauGaugeExample002Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBeauGaugeExample002Dlg)
	DDX_Control(pDX, IDC_BGV2ACTIVEXCTRL1, m_gauge1);
	DDX_Control(pDX, IDC_BGV2ACTIVEXCTRL2, m_gauge2);
	DDX_Control(pDX, IDC_BGV2ACTIVEXCTRL9, m_gauge3);
	DDX_Control(pDX, IDC_BGV2ACTIVEXCTRL7, m_gauge7);
	DDX_Control(pDX, IDC_BGV2ACTIVEXCTRL8, m_gauge8);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBeauGaugeExample002Dlg, CDialog)
	//{{AFX_MSG_MAP(CBeauGaugeExample002Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBeauGaugeExample002Dlg message handlers

BOOL CBeauGaugeExample002Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_random[0].SetAtom(0.4f);
	m_random[0].SetMinMax(0,100);

	m_random[1].SetAtom(0.1f);
	m_random[1].SetMinMax(0,100);

	m_random[2].SetAtom(0.6f);
	m_random[2].SetMinMax(0,100);

	this->SetTimer(1,1,NULL);
	this->SetTimer(2,1000,NULL);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBeauGaugeExample002Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBeauGaugeExample002Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBeauGaugeExample002Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBeauGaugeExample002Dlg::OnDestroy() 
{
	this->KillTimer(1);
	this->KillTimer(2);

	CDialog::OnDestroy();	
}

void CBeauGaugeExample002Dlg::OnTimer(UINT nIDEvent) 
{
	if(1 == nIDEvent)
	{
		//m_gauge1.SetValue(_T("Needle1"),m_random[0].GetSingle());
		m_gauge2.SetValue(_T("Needle1"),m_random[2].GetSingle());
		m_gauge2.SetValue(_T("Needle2"),m_random[1].GetSingle());
		//m_gauge3.SetValue(_T("Needle1"),m_random[0].GetSingle());
		m_gauge3.SetValue(_T("Needle1"),m_random[1].GetSingle());
	}

	if(2 == nIDEvent)
	{
		static BOOL b1 = TRUE;
		//m_gauge7.SetValue(_T("ImageStateIndicator1"),b1);
		m_gauge8.SetValue(_T("ImageStateIndicator1"),b1);
		b1 = !b1;
	}
	
	CDialog::OnTimer(nIDEvent);
}

BEGIN_EVENTSINK_MAP(CBeauGaugeExample002Dlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CBeauGaugeExample002Dlg)
	ON_EVENT(CBeauGaugeExample002Dlg, IDC_BGV2ACTIVEXCTRL3, 1 /* ValueChanged */, OnValueChangedBgv2activexctrl3, VTS_BSTR VTS_R8)
	ON_EVENT(CBeauGaugeExample002Dlg, IDC_BGV2ACTIVEXCTRL6, 1 /* ValueChanged */, OnValueChangedBgv2activexctrl6, VTS_BSTR VTS_R8)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CBeauGaugeExample002Dlg::OnValueChangedBgv2activexctrl3(LPCTSTR sName, double fValue) 
{
	m_gauge1.SetValue(_T("Needle1"),fValue);	
}

void CBeauGaugeExample002Dlg::OnValueChangedBgv2activexctrl6(LPCTSTR sName, double fValue) 
{
	m_gauge7.SetValue(_T("ImageStateIndicator1"),fValue > 0 ? 1 : 0);
	
}
